#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

#include "defines.h"

double *alloc_double(int );

void score_subsequences(int numSeq,char **seq,char **rseq,int *seqLen,
   double **pwm,int motifLen,double **score,double **rscore,char *Iseq) {

   register int ii,i,m;
   double plusScore,minusScore;
   double *colMin;
   int temp;

   colMin=alloc_double(motifLen);

   for (m=0; m<motifLen; m++) {
      colMin[m]=9999;
      for (i=0; i<4; i++) {
        if (pwm[m][i]<colMin[m]) colMin[m]=pwm[m][i];
      }
   }

   for (ii=0;  ii<numSeq; ii++) {
      if (Iseq[ii]=='0') continue;

      // plus strand
      for(i=0;  i<seqLen[ii]-motifLen+1; i++) {
         plusScore=0;
         for (m=0; m<motifLen;m++) {
            switch(seq[ii][i+m]) {
               case 'a': plusScore +=pwm[m][0]; break;
               case 'c': plusScore +=pwm[m][1]; break;
               case 'g': plusScore +=pwm[m][2]; break;
               case 't': plusScore +=pwm[m][3]; break;
               default:  plusScore +=colMin[m]; break;
            }
         }
         score[ii][i]=plusScore;
      }
      // minus strand
      for(i=0;  i<seqLen[ii]-motifLen+1; i++){
         temp=seqLen[ii]-i-motifLen;
         minusScore=0;
         for (m=0; m<motifLen;m++) {
            switch(rseq[ii][i+m]) {
               case 'a': minusScore +=pwm[m][0]; break;
               case 'c': minusScore +=pwm[m][1]; break;
               case 'g': minusScore +=pwm[m][2]; break;
               case 't': minusScore +=pwm[m][3]; break;
               default:  minusScore +=colMin[m]; break;
            }
         }
         rscore[ii][temp]=minusScore;
      }
   }
   if (colMin) { free(colMin); colMin=NULL; }
}

void score_subsequences_full(int numSeq,char **seq,char **rseq,int *seqLen,
   double **pwm,int motifLen,double **score,double **rscore) {

   register int ii,i,m;
   double plusScore,minusScore;
   double *colMin;
   int temp;

   colMin=alloc_double(motifLen);

   for (m=0; m<motifLen; m++) {
      colMin[m]=9999;
      for (i=0; i<4; i++) {
        if (pwm[m][i]<colMin[m]) colMin[m]=pwm[m][i];
      }
   }

   for (ii=0;  ii<numSeq; ii++) {
      for(i=0;  i<seqLen[ii]-motifLen+1; i++) {
         plusScore=0;
         for (m=0; m<motifLen;m++) {
            switch(seq[ii][i+m]) {
               case 'a': plusScore +=pwm[m][0]; break;
               case 'c': plusScore +=pwm[m][1]; break;
               case 'g': plusScore +=pwm[m][2]; break;
               case 't': plusScore +=pwm[m][3]; break;
               default:  plusScore +=colMin[m]; break;
            }
         }
         score[ii][i]=plusScore;
      }

      for(i=0;  i<seqLen[ii]-motifLen+1; i++){
         temp=seqLen[ii]-i-motifLen;
         minusScore=0;
         for (m=0; m<motifLen;m++) {
            switch(rseq[ii][i+m]) {
               case 'a': minusScore +=pwm[m][0]; break;
               case 'c': minusScore +=pwm[m][1]; break;
               case 'g': minusScore +=pwm[m][2]; break;
               case 't': minusScore +=pwm[m][3]; break;
               default:  minusScore +=colMin[m]; break;
            }
         }
         rscore[ii][temp]=minusScore;
      }
   }
   if (colMin) { free(colMin); colMin=NULL; }
}

